/*
 * Kandisky Graphlet
 * Copyright (C) 1999-2000 Filip Pizlo
 *
 * Based on the Kandinsky Applet
 */

import java.applet.*;
import java.awt.*;
import java.util.*;
import java.net.*;
import java.lang.reflect.*;

public class kandlet extends graphlet implements Runnable {
 public int polysize=300,polydiv=15,polymax=5,polymin=4,delta=3,
  rnddelta=3,red=10,green=0,blue=60,redfluc=6,greenfluc=3,bluefluc=12,
  ttw=100,maxcolr=256;
 Random rand=new Random();
 class rndpoly {
  int[] x,y;
  int n;
  Color c;
  public rndpoly() {
//   System.out.println("Making a new rndpoly");
   n=Math.abs(rand.nextInt())%polymax+polymin;
   x=new int[n];
   y=new int[n];
   x[0]=Math.abs(rand.nextInt())%size().width;
   y[0]=0;
   for (int i=1;i<n;i++) {
    x[i]=x[0]+(rand.nextInt()%(polysize/2));
    y[i]=y[0]-(Math.abs(rand.nextInt())%polysize);
   }
   int r=red+(Math.abs(rand.nextInt())%redfluc);
   int g=green+(Math.abs(rand.nextInt())%greenfluc);
   int b=blue+(Math.abs(rand.nextInt())%bluefluc);
   c=new Color(r%maxcolr,g%maxcolr,b%maxcolr);
//   System.out.println("Made: "+x+" "+y+" "+n+" "+c);
  }
  public boolean iterate() {
   y[0]+=delta;
   if (y[0]>size().height+polysize) return false;
   for (int i=1;i<n;i++) {
    x[i]+=(rand.nextInt()%rnddelta);
    y[i]+=(rand.nextInt()%rnddelta)+delta;
   }
   int r=c.getRed()+(Math.abs(rand.nextInt())%redfluc);
   int g=c.getGreen()+(Math.abs(rand.nextInt())%greenfluc);
   int b=c.getBlue()+(Math.abs(rand.nextInt())%bluefluc);
   c=new Color(r%maxcolr,g%maxcolr,b%maxcolr);
   return true;
  }
  public void draw(Graphics g) {
   g.setColor(c);
   g.fillPolygon(x,y,n);
  }
 }
 Vector polies=new Vector();
 Image dbuf;
 Graphics g2;
 public void init() {
  try {
   dbuf=createImage(size().width,size().height);
   g2=dbuf.getGraphics();
  } catch (Throwable e) {
   System.out.println("Error in init: "+e);
  }
 }
 public void paint(Graphics g) {
  g.drawImage(dbuf,0,0,this);
 }
 public void update(Graphics g) {
  g.drawImage(dbuf,0,0,this);
 }
 public void run() {
  try {
   Field[] fields=getClass().getFields();
   for (int i=0;i<fields.length;i++) {
    try {
     Object o=fields[i].get(this);
     if (o instanceof Integer)
      fields[i].setInt(this,Integer.parseInt(
       getParameter(fields[i].getName())));
    } catch (Throwable e) {
     System.out.println("Error setting "+fields[i].getName()+": "+e);
    }
   }
   int bign=size().width/polydiv,lim=0,cnt=0;
   Color c=new Color(red,green,blue);
   g2.setPaintMode();
   g2.setColor(c);
   g2.fillRect(0,0,size().width,size().height);
   g2.setXORMode(c);
   while (true) {
    if (polies.size()<bign) cnt++;
    if ((lim%polydiv)==0) {
     rndpoly p=new rndpoly();
     polies.addElement(p);
     cnt--;
    }
    for (int i=0;i<polies.size();i++) {
     rndpoly p=(rndpoly)polies.elementAt(i);
     p.draw(g2);
     if (!p.iterate()) {
      polies.removeElementAt(i);
      i--;
     }
    }
    Thread.sleep(ttw);
    repaint();
    lim++;
   }
  } catch (Throwable e) {
   System.out.println("Error in thread: "+e);
  }
 }
 Thread dostuff;
 public void start() {
  dostuff=new Thread(this);
  dostuff.start();
 }
 public void stop() {
  try {
   dostuff.stop();
   dostuff=null;
  } catch (Throwable e) {}
 }
}


